"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class PreviousTreatment(ProtocolElement):
    """
    In GMS, Previous Treatment of Patient
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_1 import participant as participant_1_5_0

        return {
            "previousTreatmentDate": participant_1_5_0.Date,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_1 import participant as participant_1_5_0

        return {
            "org.gel.models.participant.avro.Date": participant_1_5_0.Date,
            "org.gel.models.participant.avro.PreviousTreatment": participant_1_5_0.PreviousTreatment,
        }

    __slots__ = [
        "previousTreatmentDate",
        "previousTreatmentName",
        "previousTreatmentType",
    ]

    def __init__(
        self,
        previousTreatmentDate=None,
        previousTreatmentName=None,
        previousTreatmentType=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_5_0.PreviousTreatment model.

        :param previousTreatmentDate:
        :type previousTreatmentDate: None | Date
        :param previousTreatmentName:
        :type previousTreatmentName: None | str
        :param previousTreatmentType:
        :type previousTreatmentType: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.0"
